program fractal;
uses Dos, Crt, Graph;
{---------------------------------------------------------------------}
type TComplex = object
   x : real;
   y : real;
   constructor Init(Argx : real; Argy : real);
   function Module : real;
   procedure Show;
end;
{---------------------------------------------------------------------}
function TComplex.Module : real;
begin
   Module := sqrt(x*x + y*y);
end;
{---------------------------------------------------------------------}
constructor TComplex.Init(Argx : real; Argy : real);
begin
   x := Argx;
   y := Argy;
end;
{---------------------------------------------------------------------}
procedure TComplex.Show;
begin
   writeln;
   write(x, ' + ', y, ' i');
end;
{---------------------------------------------------------------------}
procedure Add( Z1, Z2 : TComplex; var Z3 : TComplex);
begin
   Z3.x := Z1.x + Z2.x;
   Z3.y := Z1.y + Z2.y;
end;
{---------------------------------------------------------------------}
procedure Mult( Z1, Z2 : TComplex; var Z3 : TComplex);
begin
   Z3.x := Z1.x * Z2.x - Z1.y * Z2.y;
   Z3.y := Z1.x * Z2.y + Z2.x * Z1.y;
end;
{---------------------------------------------------------------------}
const
   left=-1.5;
   top=2.0;
   right=1.5;
   bottom=-1.0;

var
   grDriver, grMode : integer;
   xi, yi, i : integer;
   Z, ZTmp1, ZTmp2, ZTmp3 : TComplex;
   C : TComplex;
   xcells, ycells, xPixelSize, yPixelSize : integer;
   xstep, ystep : real;
   mode : byte;
   prev : boolean;
   startx, starty, endy : integer;
{---------------------------------------------------------------------}
begin
{show messages}
   Writeln('This program will draw a fractal in several minutes');
   Writeln('Be patient, if You want to abort program - press any key.');
   Writeln('Press any key now to start');
   ReadKey;

{const init}
   C.x := 0;
   C.y := -1;
   mode := 8;
   case mode of
       8 : begin
           xcells:=640;
           ycells:=480;
           end;
       7 : begin
           xcells:=320;
           ycells:=240;
           end;
       6 : begin
           xcells:=160;
           ycells:=120;
           end;
       5 : begin
           xcells:=80;
           ycells:=60;
           end;
       4 : begin
           xcells:=40;
           ycells:=30;
           end;
   end;

   xPixelSize:=640 div xcells;
   yPixelSize:=480 div ycells;
   xstep:=(right-left)/xcells;
   ystep:=(top-bottom)/ycells;

   grDriver := VGA;
   grMode := VGAHI;
   initgraph(grDriver, grMode, '');
   setfillstyle(SolidFill, White);
   setcolor(White);

   for xi := 1 to xcells do
   begin
       prev := false;
       for yi := 1 to ycells do
       begin
           Z.Init(left + (xi-1)*xstep, bottom + (yi-1)*ystep);
           for i := 1 to 100 do
           begin
               Mult(Z, Z, ZTmp1);                 { Z*Z }
               Mult(C, Z, ZTmp2);                 { C*Z }
               Add(ZTmp1, ZTmp2, Z);              { Z := Z*Z + C*Z }
               if (Z.Module > 10000) then break;
               if KeyPressed then
               begin
                  closegraph;
                  Halt(1);
               end;

           end;
           if (Z.Module < 10000) then
           begin
               if (prev=false) then
               begin
                   startx := Trunc ((xi-1)*xPixelSize+1);
                   starty := Trunc(480-(yi-2)*yPixelSize-1);
                   endy := starty;
                   prev := true;
               end
               else
                   endy:= Trunc(480-(yi-2)*yPixelSize-1);
                   if yi = ycells then
                   begin
                       moveto(startx, starty);
                       lineto(startx, endy);
                       prev:=false;
                   end;
           end
           else
               if prev=true then
               begin
                   moveto(startx, starty);
                   lineto(startx, endy);
                   prev:=false;
               end;
       end;
   end;
{   OutTextXY(290, 200, 'Press any key');}
   ReadKey;
   closegraph;
end.